<id>
din1031:MemberColorLink
</id>

<version>
3.0.3
</version>

<edit file>
$sourcedir/ModSettings.php
</edit file>

<search for>
			'layout' => array(
				'title' => $txt['mods_cat_layout'],
				'href' => $scripturl . '?action=featuresettings;sa=layout;sesc=' . $context['session_id'],
			),
</search for>

<replace>
			'layout' => array(
				'title' => $txt['mods_cat_layout'],
				'href' => $scripturl . '?action=featuresettings;sa=layout;sesc=' . $context['session_id'],
			),
			'MemberColorLinks' => array(
				'title' => $txt['MemberColorLinkHeadline'],
				'href' => $scripturl . '?action=featuresettings;sa=MemberColorLinks;sesc=' . $context['session_id'],
			),
</replace>

<search for>
		'layout' => 'ModifyLayoutSettings',
</search for>

<replace>
		'layout' => 'ModifyLayoutSettings',
		'MemberColorLinks' => 'ModifyMemberColorLinksSettings',
</replace>

<search for>
	$context['post_url'] = $scripturl . '?action=featuresettings2;save;sa=karma';
	$context['settings_title'] = $txt['smf293'];

	prepareDBSettingContext($config_vars);
}
</search for>

<add after>
function ModifyMemberColorLinksSettings()
{
	global $txt, $scripturl, $context, $settings, $sc;

	$config_vars = array(
			// Standard Membercolor?
			array('check', 'MemberColorLink'),
			array('check', 'MemberColorLinkOldSpanStyle'),
		'',
			//Some Stat Settings
			array('check', 'MemberColorLatestMember'),
			array('check', 'MemberColorStats'),
			array('check', 'MemberColorWhoIsOnline'),
		'',
			//Thread and Boardsettings
			array('check', 'MemberColorThreadOwner'),
			array('check', 'MemberColorThreadLastPost'),
			array('check', 'MemberColorThreadChild'),
		'',
			//Birthday and Calendar 
			array('check', 'MemberColorModeratorLinks'),
			array('check', 'MemberColorBoardindex'),
			array('check', 'MemberColorBirthday'),
		'',
			//Some Recent Things
			array('check', 'MemberColorRecentOwner'),
			array('check', 'MemberColorRecentLastPost'),
		'',
			// PM Colors
			array('check', 'MemberColorInbox'),
			array('check', 'MemberColorOutbox'),
		'',
			//The Heavy Member Search Option
			array('check' , 'MemberColorAllSearch'),
		'',
			//Birthday Color
			array('text', 'MemberColorBanned'),
			//Guest Color
			array('text', 'MemberColorGuests'),
			//Birthday User Color
			array('text', 'MemberColorBirthdayColor'),
	);

	// Saving?
	if (isset($_GET['save']))
	{
		saveDBSettings($config_vars);
		redirectexit('action=featuresettings;sa=MemberColorLinks');
	}

	$context['post_url'] = $scripturl . '?action=featuresettings2;save;sa=MemberColorLinks';
	$context['settings_title'] = $txt['MemberColorLinkHeadline'];

	prepareDBSettingContext($config_vars);
}
</add after>

<edit file>
$sourcedir/Load.php
</edit file>

<search for>
	array loadMemberData(array members, bool is_name = false, string set = 'normal')
</search for>

<replace>
	array load_OnlineColors(array members, bool returnarray = true, bool singleuser = false)
		- This function is for Modcreators who like to color the nicks if the MemberColorLink is installed
		  with this function the user can check if the function exists and load the colors if needed.
		  But please load so many ids as possible at one time, to reduce the database querys.
		  To Check if the function exist use if(!empty($modSettings['MemberColorLinkInstalled'])) {}
		- return a array with follow informations
			array(id_member => array(online_color => '', colored_name => '', colored_link => '');
		- The option single user will only return one user color as array, without id before.
		- chache datas the global $color_profile (only the db data, not the array data above)
		- return "false" on nothing loaded!

	bool/string load_mod_color(bool return = false, update = null)
		- Store the Moderator Color into the $context['modGroupColor']
		- "return = true" will return this color as string
		- This function use only one time the query to load this color
		- update is for the fast update of the moderator color

	bool compare_birthday(string brtihday)
		- Compare Today with the Birthday, true if today his/her birthday 

	array loadMemberData(array members, bool is_name = false, string set = 'normal')
</replace>

<search for>
	// UTF-8 in regular expressions is unsupported on PHP(win) versions < 4.2.3.
</search for>

<replace>
	//This setting should never chached, it show others that member color link is installed!
	$modSettings['MemberColorLinkInstalled'] = function_exists('load_onlineColors') ? 1 : 0;
	$modSettings['MemberColorLinkVersion'] = '3.0.3';

	// UTF-8 in regular expressions is unsupported on PHP(win) versions < 4.2.3.
</replace>

<search for>
	global $user_profile, $db_prefix, $modSettings, $board_info;
</search for>

<replace>
	global $user_profile, $db_prefix, $modSettings, $board_info;
	global $color_profile; //This is for Preloaded Data, i will not load it twice you know ;)
</replace>

<search for>
			$loaded_ids[] = $data['ID_MEMBER'];
			$user_profile[$data['ID_MEMBER']] = $data;
</search for>

<replace>
			$loaded_ids[] = $data['ID_MEMBER'];
			$user_profile[$data['ID_MEMBER']] = $data;
			//Happy Birthday Color to this user :D
			if(!empty($modSettings['MemberColorBirthdayColor']) && !empty($data['birthdate']) && compare_colorBirthdate($data['birthdate'])) {
				$user_profile[$row['ID_MEMBER']]['post_group_color'] = $modSettings['MemberColorBirthdayColor'];
				$user_profile[$row['ID_MEMBER']]['member_group_color'] = $modSettings['MemberColorBirthdayColor'];
			}
			//Color Banned user, replace there color... hope they are not moderators ;P?
			if(!empty($modSettings['MemberColorBanned']) && isset($data['is_activated']) && $data['is_activated'] >= 10) {
				$user_profile[$row['ID_MEMBER']]['post_group_color'] = $modSettings['MemberColorBanned'];
				$user_profile[$row['ID_MEMBER']]['member_group_color'] = $modSettings['MemberColorBanned'];
			}
			//Memeber Color Link will used Chached Data, too wheee.
			if($set == 'normal' || $set == 'profile') //This are the only sets with the info the mod need.
				$color_profile[$data['ID_MEMBER']] = array(
					'ID_MEMBER' => $data['ID_MEMBER'],
					'realName' => $data['realName'],
					'member_group_color' => $user_profile[$row['ID_MEMBER']]['member_group_color'],		
					'post_group_color' => $user_profile[$row['ID_MEMBER']]['post_group_color'],		
				);
</replace>

<search for>
			$user_profile[$row['ID_MEMBER']] = $row;
</search for>

<replace>
			$user_profile[$row['ID_MEMBER']] = $row;
			//Happy Birthday Color ;D Hope you love it :D
			if(!empty($modSettings['MemberColorBirthdayColor']) && !empty($row['birthdate']) && compare_colorBirthdate($row['birthdate'])) {
				$user_profile[$row['ID_MEMBER']]['post_group_color'] = $modSettings['MemberColorBirthdayColor'];
				$user_profile[$row['ID_MEMBER']]['member_group_color'] = $modSettings['MemberColorBirthdayColor'];
			}
			//Color Banned user, replace there color... hope they are not moderators ;P?
			if(!empty($modSettings['MemberColorBanned']) && isset($row['is_activated']) && $row['is_activated'] >= 10) {
				$user_profile[$row['ID_MEMBER']]['post_group_color'] = $modSettings['MemberColorBanned'];
				$user_profile[$row['ID_MEMBER']]['member_group_color'] = $modSettings['MemberColorBanned'];
			}
			//Memeber Color Link Data, i store them for later use
			if($set == 'normal' || $set == 'profile') //This are the only sets with the infos i need.
				$color_profile[$row['ID_MEMBER']] = array(
					'ID_MEMBER' => $row['ID_MEMBER'],
					'realName' => $row['realName'],
					'member_group_color' => $user_profile[$row['ID_MEMBER']]['member_group_color'],		
					'post_group_color' => $user_profile[$row['ID_MEMBER']]['post_group_color'],		
				);
</replace>

<search for>
			cache_put_data('moderator_group_info', $row, 480);
</search for>

<replace>
			cache_put_data('moderator_group_info', $row, 480);
			if(isset($modSettings['MemberColorLinkModColor']) && $modSettings['MemberColorLinkModColor'] != $row['member_group_color'])
				updateSettings(array('MemberColorLinkModColor' => $row['member_group_color']));
</replace>

<search for>
			if (!empty($row['member_group_color']))
				$user_profile[$id]['member_group_color'] = $row['member_group_color'];
</search for>

<replace>
			if (!empty($row['member_group_color'])) {
				$user_profile[$id]['member_group_color'] = $row['member_group_color'];
				//Replace this, too because i will not forget it ;D (Member Color Link)
				$color_profile[$id]['member_group_color'] = $row['member_group_color'];
			}
</replace>

<search for>
	$profile = $user_profile[$user];
</search for>

<replace>
	$profile = $user_profile[$user];

	//Prepare some colored Datas :D Member Color Link give some Infos back 8)
	$coloredData = load_onlineColors($user, true, true);	
</replace>

<search for>
		'username' => &$profile['memberName'],
		'name' => &$profile['realName'],
</search for>

<replace>
		'username' => &$profile['memberName'],
		'name' => &$profile['realName'],
		'colored_name' => $coloredData['colored_name'],
		'online_color' => $coloredData['online_color'],
</replace>

<search for>
		'link' => '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '">' . $profile['realName'] . '</a>',
</search for>

<replace>
		'link' => $coloredData['colored_link'],
		'colorless_link' => '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '">' . $profile['realName'] . '</a>',
</replace>

<search for>
// Load a theme, by ID.
</search for>

<replace>
//This is the universial load colors function, can be used by each person who need it :)
//I think it's intressting for mod Creators =D
//SMF 1.1.x Version

function load_onlineColors($users, $returnarray = true, $singleuser = false) {
	global $color_profile, $db_prefix, $modSettings;
	static $color_array;

	//Make something for sure :)
	if(!isset($color_profile))
		$color_profile = array();
	//This will hold the array data for later ;)
	if(!isset($color_array))
		$color_array = array();
	//Set a standard empty array for guest errors ;) (Deleted users, which are not resetet)
	if(!isset($color_profile[0]))
		$color_profile[0] = array('member_group_color' => '', 'post_group_color' => '');
	
	// Can't just look for no users :P.
	if (empty($users))
		return false;

	// Make sure it's an array.
	$users = !is_array($users) ? array($users) : array_unique($users);

	//Now i will use this as a chache, too
	$loaded_ids = array();
	$all_loaded_ids = array_keys($color_profile);
	//All the users that allready loaded
	$loaded_ids = array_intersect($all_loaded_ids, $users);
	//Now i need only the new users to load
	$users = array_diff($users, $all_loaded_ids);
	
	if(!empty($users)) {
		// Load the data.
		$request = db_query("
			SELECT
			mem.ID_MEMBER AS ID_MEMBER, mem.realName AS realName, mem.is_activated AS is_activated,
			mem.birthdate AS birthdate,
			mg.onlineColor AS member_group_color, IFNULL(mg.groupName, '') AS member_group,
			pg.onlineColor AS post_group_color, IFNULL(pg.groupName, '') AS post_group
			FROM {$db_prefix}members AS mem
			LEFT JOIN {$db_prefix}membergroups AS pg ON (pg.ID_GROUP = mem.ID_POST_GROUP)
			LEFT JOIN {$db_prefix}membergroups AS mg ON (mg.ID_GROUP = mem.ID_GROUP)
			WHERE mem.ID_MEMBER ".(count($users) == 1 ? " = '" . current($users) . "'" : " IN ('" . implode("', '", $users) . "')"), __FILE__, __LINE__);

		while ($row = mysql_fetch_assoc($request))
		{
			$loaded_ids[] = $row['ID_MEMBER'];
			$color_profile[$row['ID_MEMBER']] = $row;
			//Happy Birthday Color ;D Hope you love it :D
			if(!empty($modSettings['MemberColorBirthdayColor']) && !empty($row['birthdate']) && compare_colorBirthdate($row['birthdate'])) {
				$color_profile[$row['ID_MEMBER']]['post_group_color'] = $modSettings['MemberColorBirthdayColor'];
				$color_profile[$row['ID_MEMBER']]['member_group_color'] = $modSettings['MemberColorBirthdayColor'];
			}
			//Banned User hope it is not a mod ;)
			if(!empty($modSettings['MemberColorBanned']) && isset($row['is_activated']) && $row['is_activated'] >= 10) {
				$color_profile[$row['ID_MEMBER']]['post_group_color'] = $modSettings['MemberColorBanned'];
				$color_profile[$row['ID_MEMBER']]['member_group_color'] = $modSettings['MemberColorBanned'];
			}
		}
		mysql_free_result($request);
	}
	
	//Build the Array ;D
	$array = array();
	if(!empty($loaded_ids) && $returnarray == true) {
		global $txt, $scripturl, $board_info;
		foreach($loaded_ids as $id) {
			$mod = false;
			//Rewrite Moderator Color!
			if(isset($board_info['moderators'][$id]) && (empty($color_array[$id]) || !$color_array[$id]['moderator'])) {
				if(isset($color_array[$id]))
					unset($color_array[$id]);
				if(empty($color_profile[$id]['member_group_color']))
					$color_profile[$id]['member_group_color'] = load_mod_color(true);
				$mod = true;
			}
			//Load a prepared Data?
			if(!isset($color_array[$id])) {
				$profile = $color_profile[$id];
				$onlineColor = !empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color'];
				$color_array[$id] = array(
					'id' => $id,
					'online_color' => $onlineColor,
					'colored_name' => (!empty($onlineColor) ? '<span style="color:'.$onlineColor.';">' : '' ) . $profile['realName'] . (!empty($onlineColor) ? '</span>' : ''),
					//Make it compatible old and new style
					'colored_link' => (empty($modSettings['MemberColorLinkOldSpanStyle']) ?
						'<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"'.(!empty($onlineColor) ? ' style="color:'.$onlineColor.';"' : '').'>' . $profile['realName'] .'</a>' :
						'<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '">' . ( !empty($profile['member_group_color']) || !empty($profile['post_group_color']) ? '<span style="color:'. ( !empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color'] ) .';">' : '' ) . $profile['realName'] . (!empty($profile['member_group_color']) || !empty($profile['post_group_color']) ? '</span>' : '' ).'</a>'),
					'moderator' => $mod,
				);
			}
			$array[$id] =	$color_array[$id]; 
		}	
	}

	//This option return only a single user, i hope you know what you do ;)
	if($singleuser === true)
		$array = current($array);

	//Return that what should returned XD
	return (empty($loaded_ids) ? false : ($returnarray == true ? $array : $loaded_ids));
}

//Load in a fast way the Moderator color... i think i cashe it sometimes...
//$update it's only for me that the mod is fast ;)
function load_mod_color($return = false, $update = null) {
	global $context, $db_prefix, $modSettings;

	//Need a update?
	if($update !== null && $return === false) {
		updateSettings(array('MemberColorLinkModColor' => $update));
		return true;
	}

	//This settings is loaded in the loadMemberData
	if(isset($modSettings['MemberColorLinkModColor']) && !isset($context['modGroupColor']))
		$context['modGroupColor'] = $modSettings['MemberColorLinkModColor'];
	
	if(!isset($context['modGroupColor'])) {
		$context['modGroupColor'] = '';
		$modColor = db_query("
			SELECT onlineColor AS online_color
			FROM {$db_prefix}membergroups
			WHERE ID_GROUP = 3
			LIMIT 1", __FILE__, __LINE__);
		list($context['modGroupColor']) = mysql_fetch_row($modColor);
		mysql_free_result($modColor);
	}

	//Need a update?
	if(!isset($modSettings['MemberColorLinkModColor']))
		updateSettings(array('MemberColorLinkModColor' => $context['modGroupColor']));
	
	$return = (bool) $return;
	return $return ? $context['modGroupColor'] : true;
}
//Compare Birthday, return true on todays brithday
function compare_colorBirthdate($birthday = '') {
	if(empty($birthday))
		return false;
	$d = explode('-',trim($birthday));
	if(count($d) != 3)
		return false;
	return date('md') == date('md', mktime(0,0,0,$d['1'],$d['2'],0)) ? true : false;
}

// Load a theme, by ID.
</replace>

<edit file>
$sourcedir/MessageIndex.php
</edit file>

<search for>
	// Aren't children wonderful things?
	$result = db_query("
</search for>

<add before>
	//Set some standard Variables for the MemberColorLink
	$MemberSetColor = false;
	if (!empty($modSettings['MemberColorThreadOwner']) || !empty($modSettings['MemberColorThreadLastPost']) || !empty($modSettings['MemberColorChild']) || (!empty($modSettings['MemberColorWhoIsOnline']) && !empty($settings['display_who_viewing'])))
		$context['MemberColor_ID_MEMBER'] = array();

</add before>

<search for>
				$theboards[] = $row_board['ID_BOARD'];
</search for>

<add after>

				//The Last Posts of the Children MemberColor.
				if (!empty($modSettings['MemberColorThreadChild']) && !empty($row_board['ID_MEMBER'])) {
						$context['MemberColor_ID_MEMBER'][$row_board['ID_MEMBER']] = $row_board['ID_MEMBER'];
						$MemberSetColor = true;
				}
</add after>

<search for>
			if (empty($row['showOnline']))
				$context['view_num_hidden']++;
		}
		$context['view_num_guests'] = mysql_num_rows($request) - count($context['view_members']);
		mysql_free_result($request);
</search for>

<replace>
				if (!empty($modSettings['MemberColorWhoIsOnline'])) {
					$context['MemberColor_ID_MEMBER'][$row['ID_MEMBER']] = $row['ID_MEMBER'];
					$MemberSetColor = true;
				}

			if (empty($row['showOnline']))
				$context['view_num_hidden']++;
		}
		$context['view_num_guests'] = mysql_num_rows($request) - count($context['view_members']);
		mysql_free_result($request);
</replace>

<search for>
			if (!$pre_query)
				$topic_ids[] = $row['ID_TOPIC'];
</search for>

<add after>

		//I need to collect some IDs for the MemberColor :).
		if (!empty($modSettings['MemberColorThreadOwner']) && !empty($row['firstID_MEMBER'])) {
				$context['MemberColor_ID_MEMBER'][$row['firstID_MEMBER']] = $row['firstID_MEMBER'];
				$MemberSetColor = true;
		}
		//Oh i need the Last Post ID, too ;)
		if (!empty($modSettings['MemberColorThreadLastPost']) && !empty($row['lastID_MEMBER'])) {
				$context['MemberColor_ID_MEMBER'][$row['lastID_MEMBER']] = $row['lastID_MEMBER'];
				$MemberSetColor = true;
		}
</add after>

<search for>
			determineTopicClass($context['topics'][$row['ID_TOPIC']]);
		}
		mysql_free_result($result);
</search for>

<add after>
		//Now let's replace the orginal link to the Color Link ;)
		if ($MemberSetColor && !empty($context['MemberColor_ID_MEMBER'])) {
			$colorDatas = load_onlineColors($context['MemberColor_ID_MEMBER']);
			//You are not know what you do ;P Colors allready loaded :D
			if(!empty($modSettings['MemberColorModeratorLinks']) && !empty($theboards)) {
				//Okay now... do a heavy serach for moderators... only jokeing... but you know... it look so ugly ;)
				$onlineColor = load_mod_color(true);
				foreach($theboards as $boardid_memcolor) {
					//Reset it :D
					$context['boards'][$boardid_memcolor]['link_moderators'] = array();
					global $color_profile;
					foreach($context['boards'][$boardid_memcolor]['moderators'] as $moderators) {
						$cmemcolid = $moderators['id'];
						//Replace "Profil of" with "Moderator" ;D
						$link = str_replace($txt[92], $txt[62], $colorDatas[$cmemcolid]['colored_link']); 
						if(empty($colorDatas[$cmemcolid]['online_color']) && !empty($onlineColor))
							$link = '<a href="' . $scripturl . '?action=profile;u=' . $color_profile[$cmemcolid]['ID_MEMBER'] . '" title="' . $txt[62] . ' ' . $color_profile[$cmemcolid]['realName'] . '"'.(!empty($modSettings['MemberColorLinkOldSpanStyle']) ? '><span style="color:'.$onlineColor.';">' : ' style="color:'.$onlineColor.';">') . $color_profile[$cmemcolid]['realName'] . (!empty($modSettings['MemberColorLinkOldSpanStyle']) ? '</span>' : '').'</a>';
						//Standard Color ;)
						$context['boards'][$boardid_memcolor]['moderators'][$cmemcolid]['link'] = $link;
						//Creat the new list...
						$context['boards'][$boardid_memcolor]['link_moderators'][] = $link;
					}
				}
			}
			//Need the Childs some Colors XD
			if (!empty($modSettings['MemberColorThreadChild']) && !empty($theboards))
				foreach($theboards as $boardid_memcolor) {
					//My Childs need a Member Color ;)
					$cmemcolid = $context['boards'][$boardid_memcolor]['last_post']['member']['id'];
					if(!empty($colorDatas[$cmemcolid]['colored_link']))
						$context['boards'][$boardid_memcolor]['last_post']['member']['link'] = $colorDatas[$cmemcolid]['colored_link'];
				}
			//The Owner or the Last Post of the thread
			if (!empty($modSettings['MemberColorThreadOwner']) || !empty($modSettings['MemberColorThreadLastPost']))
				foreach($topic_ids as $topicid_memcolor) {
					//First the Thread Owner Link
					if (!empty($modSettings['MemberColorThreadOwner'])) {
						$cmemcolid = $context['topics'][$topicid_memcolor]['first_post']['member']['id'];
					if(!empty($colorDatas[$cmemcolid]['colored_link']))
							$context['topics'][$topicid_memcolor]['first_post']['member']['link'] = $colorDatas[$cmemcolid]['colored_link'];
					}
					//Or the Last Post Link ;)
					if (!empty($modSettings['MemberColorThreadLastPost'])) {
						$cmemcolid = $context['topics'][$topicid_memcolor]['last_post']['member']['id'];
					if(!empty($colorDatas[$cmemcolid]['colored_link']))
							$context['topics'][$topicid_memcolor]['last_post']['member']['link'] = $colorDatas[$cmemcolid]['colored_link'];
					}
				}
			if (!empty($settings['display_who_viewing']) && !empty($modSettings['MemberColorWhoIsOnline']) && !empty($context['view_members'])) {
				//I need the new not numeric keys :)
				$klist = array_keys($context['view_members']);
				foreach($klist as $value) {
					$id = $context['view_members'][$value]['id'];
					//Let's replace Who is online colors...
					$context['view_members'][$value]['link'] = $colorDatas[$id]['colored_link'];
					//Somehow the 'view_members_list' must be the same as before *g*, i don't like the hidden users...
					if (!$context['view_members'][$value]['hidden'] || allowedTo('moderate_forum'))
						$context['view_members_list'][$value] = ($context['view_members'][$value]['hidden'] ? '<i>' : '').$colorDatas[$id]['colored_link'].($context['view_members'][$value]['hidden'] ? '</i>' : '');
				}
			}
		}
</add after>

<search for>
	if (!empty($board_info['moderators']))
	{
		foreach ($board_info['moderators'] as $mod)
			$context['link_moderators'][] ='<a href="' . $scripturl . '?action=profile;u=' . $mod['id'] . '" title="' . $txt[62] . '">' . $mod['name'] . '</a>';
</search for>

<replace>
	if (!empty($board_info['moderators']))
	{
		//I hate it in this way... but what should i do ;)
		if(!empty($modSettings['MemberColorModeratorLinks'])) {
			foreach($board_info['moderators'] as $mod)
				$c[$mod['id']] = $mod['id'];
			$colorDatas = load_onlineColors($c);
			foreach ($board_info['moderators'] as $mod) 
				$context['link_moderators'][] = str_replace($txt[92], $txt[62], $colorDatas[$mod['id']]['colored_link']); 
		}
		else
			foreach ($board_info['moderators'] as $mod)
				$context['link_moderators'][] ='<a href="' . $scripturl . '?action=profile;u=' . $mod['id'] . '" title="' . $txt[62] . '">' . $mod['name'] . '</a>';
</replace>

<search for>
			if (!empty($row_board['ID_MODERATOR']))
			{
</search for>

<replace>
			if (!empty($row_board['ID_MODERATOR']))
			{
				//Color the Mods, too...
				if(!empty($modSettings['MemberColorModeratorLinks'])) {
					$MemberSetColor = true;
					$context['MemberColor_ID_MEMBER'][$row_board['ID_MODERATOR']] = $row_board['ID_MODERATOR'];
				}
</replace>

<search for>
							'link' => $row_board['posterName'] != '' ? (!empty($row_board['ID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row_board['ID_MEMBER'] . '">' . $row_board['realName'] . '</a>' : $row_board['realName']) : $txt[470],
</search for>

<replace>
							'link' => $row_board['posterName'] != '' ? (!empty($row_board['ID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row_board['ID_MEMBER'] . '">' . $row_board['realName'] . '</a>' : (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row_board['realName'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '')) : $txt[470],
</replace>

<search for>
						'link' => $row['posterName'] != '' ? (!empty($row['ID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['realName'] . '</a>' : $row['realName']) : $txt[470],
</search for>

<replace>
						'link' => $row['posterName'] != '' ? (!empty($row['ID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['realName'] . '</a>' : (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row['realName'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '')) : $txt[470],
</replace>

<search for>
						'link' => !empty($row['firstID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['firstID_MEMBER'] . '" title="' . $txt[92] . ' ' . $row['firstDisplayName'] . '">' . $row['firstDisplayName'] . '</a>' : $row['firstDisplayName']
</search for>

<replace>
						'link' => !empty($row['firstID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['firstID_MEMBER'] . '" title="' . $txt[92] . ' ' . $row['firstDisplayName'] . '">' . $row['firstDisplayName'] . '</a>' : (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row['firstDisplayName'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '')
</replace>

<search for>
						'link' => !empty($row['lastID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['lastID_MEMBER'] . '">' . $row['lastDisplayName'] . '</a>' : $row['lastDisplayName']
</search for>

<replace>
						'link' => !empty($row['lastID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['lastID_MEMBER'] . '">' . $row['lastDisplayName'] . '</a>' : (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row['lastDisplayName'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '')
</replace>

<edit file>
$sourcedir/BoardIndex.php
</edit file>

<search for>
			if (!empty($row_board['ID_MODERATOR']))
			{
</search for>

<replace>
			if (!empty($row_board['ID_MODERATOR']))
			{
				//Color the Mods, too...
				if(!empty($modSettings['MemberColorModeratorLinks'])) {
					$context['MemberColor_ID_MEMBER'][$row_board['ID_MODERATOR']] = $row_board['ID_MODERATOR'];
					$context['MemberColor_ModBoard'][$isChild ? $row_board['ID_PARENT'] : $row_board['ID_BOARD']] = array(
						'bid' => ($isChild ? $row_board['ID_PARENT'] : $row_board['ID_BOARD']),
						'cat' => $row_board['ID_CAT']
					);
				}
</replace>

<search for>
				'link' => $row_board['posterName'] != '' ? (!empty($row_board['ID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row_board['ID_MEMBER'] . '">' . $row_board['realName'] . '</a>' : $row_board['realName']) : $txt[470],
</search for>

<replace>
				'link' => $row_board['posterName'] != '' ? (!empty($row_board['ID_MEMBER']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row_board['ID_MEMBER'] . '">' . $row_board['realName'] . '</a>' : (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row_board['realName'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '')) : $txt[470],
</replace>

<search for>
			'start' => 'msg' . $row_board['new_from'],
			'topic' => $row_board['ID_TOPIC']
		);
</search for>

<add after>
		if (!empty($modSettings['MemberColorBoardindex']) && !empty($row_board['ID_MEMBER'])) {
			$context['MemberColor_ID_MEMBER'][$row_board['ID_MEMBER']] = $row_board['ID_MEMBER'];
			$MemberColor_board[$isChild ? $row_board['ID_PARENT'] : $row_board['ID_BOARD']] = array(
			'bid' => ($isChild ? $row_board['ID_PARENT'] : $row_board['ID_BOARD']),
			'cat' => $row_board['ID_CAT']);
		}
</add after>

<search for>
		// Determine a global most recent topic.
		if (!empty($row_board['posterTime']) && forum_time(true, $row_board['posterTime']) > $most_recent_topic['timestamp'])
			$most_recent_topic = array(
				'timestamp' => forum_time(true, $row_board['posterTime']),
				'ref' => &$this_category[$isChild ? $row_board['ID_PARENT'] : $row_board['ID_BOARD']]['last_post'],
			);
	}
	mysql_free_result($result_boards);
</search for>

<add after>
	//The latest member?
	if (!empty($modSettings['latestMember']) && !empty($modSettings['MemberColorLatestMember']))
		$context['MemberColor_ID_MEMBER'][$modSettings['latestMember']] = $modSettings['latestMember'];

	// Know set the colors for the last post...
	if (!empty($context['MemberColor_ID_MEMBER'])) {
		$colorDatas = load_onlineColors($context['MemberColor_ID_MEMBER']);
		$cmemcolid = null;

		//So the BoardIndex need colored links
		if (!empty($modSettings['MemberColorBoardindex']) && !empty($MemberColor_board))
			foreach($MemberColor_board as $boardid_memcolor) {
				$cmemcolid = $context['categories'][$boardid_memcolor['cat']]['boards'][$boardid_memcolor['bid']]['last_post']['member']['id'];
				if(!empty($colorDatas[$cmemcolid]['colored_link']))
					$context['categories'][$boardid_memcolor['cat']]['boards'][$boardid_memcolor['bid']]['last_post']['member']['link'] = $colorDatas[$cmemcolid]['colored_link'];
			}

		//You are not know what you do ;P Colors allready loaded :D
		if(!empty($modSettings['MemberColorModeratorLinks']) && !empty($context['MemberColor_ModBoard'])) {
			//This site will evertime use the correct Moderator Color, for this i need a extra query, 
			//because at the moment i don't know the correct color
			$onlineColor = load_mod_color(true);
			foreach($context['MemberColor_ModBoard'] as $boardid_memcolor) {
				global $color_profile;
				//Reset it :D
				$context['categories'][$boardid_memcolor['cat']]['boards'][$boardid_memcolor['bid']]['link_moderators'] = array();
				foreach($context['categories'][$boardid_memcolor['cat']]['boards'][$boardid_memcolor['bid']]['moderators'] as $moderators) {
					$cmemcolid = $moderators['id'];
					//Replace "Profil of" with "Moderator" ;D
					$link = str_replace($txt[92], $txt[62], $colorDatas[$cmemcolid]['colored_link']); 
					if(empty($colorDatas[$cmemcolid]['online_color']) && !empty($onlineColor))
						$link = '<a href="' . $scripturl . '?action=profile;u=' . $color_profile[$cmemcolid]['ID_MEMBER'] . '" title="' . $txt[62] . ' ' . $color_profile[$cmemcolid]['realName'] . '"'.(!empty($modSettings['MemberColorLinkOldSpanStyle']) ? '><span style="color:'.$onlineColor.';">' : ' style="color:'.$onlineColor.';">') . $color_profile[$cmemcolid]['realName'] . (!empty($modSettings['MemberColorLinkOldSpanStyle']) ? '</span>' : '').'</a>';
					$context['categories'][$boardid_memcolor['cat']]['boards'][$boardid_memcolor['bid']]['moderators'][$cmemcolid]['link'] = $link;
					//Create the new list...
					$context['categories'][$boardid_memcolor['cat']]['boards'][$boardid_memcolor['bid']]['link_moderators'][] = $link;
				}
			}
		}
	}
</add after>

<search for>
			lo.ID_MEMBER, lo.logTime, mem.realName, mem.memberName, mem.showOnline,
</search for>

<replace>
			lo.ID_MEMBER, lo.logTime, mem.realName, mem.memberName, mem.showOnline,
			mem.birthdate as birthdate, mem.is_activated as is_activated,
</replace>

<search for>
			$context['num_users_hidden']++;
			continue;
		}
</search for>

<replace>
			$context['num_users_hidden']++;
			continue;
		}
		//Happy Birthday Color ;D Hope you love it :D
		if(!empty($modSettings['MemberColorBirthdayColor']) && !empty($row['birthdate']) && compare_colorBirthdate($row['birthdate']))
			$row['onlineColor'] = $modSettings['MemberColorBirthdayColor'];
		//Color Banned user, replace there color...?
		if(!empty($modSettings['MemberColorBanned']) && isset($row['is_activated']) && $row['is_activated'] >= 10)
			$row['onlineColor'] = $modSettings['MemberColorBanned'];
</replace>

<edit file>
$sourcedir/Calendar.php
</edit file>

<search for>
	$bday = array();
</search for>

<add after>
	//Set some standard Variables for the MemberColorLink
	$MemberSetColor = false;
	if (!empty($modSettings['MemberColorBirthday'])) {
		$context['MemberColor_ID_MEMBER'] = array();
	}
</add after>

<search for>
		$bday[$age_year . substr($row['birthdate'], 4)][] = array(
			'id' => $row['ID_MEMBER'],
			'name' => $row['realName'],
			'age' => $row['birthYear'] > 4 && $row['birthYear'] <= $age_year ? $age_year - $row['birthYear'] : null,
			'is_last' => false
		);
	}
	mysql_free_result($result);
</search for>

<replace>
		$bday[$age_year . substr($row['birthdate'], 4)][] = array(
			'id' => $row['ID_MEMBER'],
			'name' => $row['realName'],
			'age' => $row['birthYear'] > 4 && $row['birthYear'] <= $age_year ? $age_year - $row['birthYear'] : null,
			'is_last' => false
		);

		//I need to collect some IDs for the MemberColor :).
		if (!empty($modSettings['MemberColorBirthday']) && !empty($row['ID_MEMBER'])) {
			$context['MemberColor_ID_MEMBER'][$row['ID_MEMBER']] = $row['ID_MEMBER'];
			$MemberSetColor = true;
		}
	}
	mysql_free_result($result);

	if ($MemberSetColor && !empty($context['MemberColor_ID_MEMBER'])) {
		$colorDatas = load_onlineColors($context['MemberColor_ID_MEMBER']);
		$cmemcolid = null;

		//So i need only the colors... Sorry this must changed in the theme, too
		if (!empty($modSettings['MemberColorBirthday']))
			if (is_array($bday))
				foreach ($bday as $memcalkv => $memcalva)
					foreach ($memcalva as $memcalidkv => $memcalid) {
						//Old Version Compatible...
						$bday[$memcalkv][$memcalidkv]['color'] = $colorDatas[$memcalid['id']]['online_color'];
						//New Style
						$bday[$memcalkv][$memcalidkv]['colored_link'] = $colorDatas[$memcalid['id']]['colored_link'];
					}
	}
</replace>

<edit file>
$sourcedir/Display.php
</edit file>

<search for>
	if (!empty($board_info['moderators']))
	{
		// Add a link for each moderator...
		foreach ($board_info['moderators'] as $mod)
			$context['link_moderators'][] = '<a href="' . $scripturl . '?action=profile;u=' . $mod['id'] . '" title="' . $txt[62] . '">' . $mod['name'] . '</a>';
</search for>

<replace>
	if (!empty($board_info['moderators']))
	{
		//I hate it in this way... but what should i do ;)
		if(!empty($modSettings['MemberColorModeratorLinks'])) {
			foreach($board_info['moderators'] as $mod)
				$c[$mod['id']] = $mod['id'];
			$colorDatas = load_onlineColors($c);
			foreach ($board_info['moderators'] as $mod) 
				$context['link_moderators'][] = str_replace($txt[92], $txt[62], $colorDatas[$mod['id']]['colored_link']); 
		}
		else
			foreach ($board_info['moderators'] as $mod)
				$context['link_moderators'][] ='<a href="' . $scripturl . '?action=profile;u=' . $mod['id'] . '" title="' . $txt[62] . '">' . $mod['name'] . '</a>';
</replace>

<search for>
		$memberContext[$message['ID_MEMBER']]['group'] = $txt[28];
		$memberContext[$message['ID_MEMBER']]['link'] = $message['posterName'];
</search for>

<replace>
		$memberContext[$message['ID_MEMBER']]['group'] = $txt[28];
		$memberContext[$message['ID_MEMBER']]['link'] = (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$message['posterName'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '');
</replace>

<search for>
			if (empty($row['showOnline']))
				$context['view_num_hidden']++;
		}

		// The number of guests is equal to the rows minus the ones we actually used ;).
		$context['view_num_guests'] = mysql_num_rows($request) - count($context['view_members']);
		mysql_free_result($request);
</search for>

<replace>
				if (!empty($modSettings['MemberColorWhoIsOnline'])) {
					$context['MemberColor_ID_MEMBER'][$row['ID_MEMBER']] = $row['ID_MEMBER'];
				}

				if (empty($row['showOnline']))
					$context['view_num_hidden']++;
			}

		// The number of guests is equal to the rows minus the ones we actually used ;).
		$context['view_num_guests'] = mysql_num_rows($request) - count($context['view_members']);
		mysql_free_result($request);
</replace>

<search for>
		// Sort the list.
		krsort($context['view_members']);
		krsort($context['view_members_list']);
	}
</search for>

<add after>
	// Somehow i can do the colors for this in two steps... because the split between first part and the messages...
	if (!empty($context['MemberColor_ID_MEMBER'])) {
		$colorDatas = load_onlineColors($context['MemberColor_ID_MEMBER']);
		//Color for the who is online ;)
		if (!empty($settings['display_who_viewing']) && !empty($modSettings['MemberColorWhoIsOnline']) && !empty($context['view_members'])) {
			//I need the new not numeric keys :)
			$klist = array_keys($context['view_members']);
			foreach($klist as $value) {
				$id = $context['view_members'][$value]['id'];
				//Let's replace Who is online colors...
				$context['view_members'][$value]['link'] = $colorDatas[$id]['colored_link'];
				//Somehow the 'view_members_list' must be the same as before *g*, i don't like the hidden users...
				if (!$context['view_members'][$value]['hidden'] || allowedTo('moderate_forum'))
					$context['view_members_list'][$value] = ($context['view_members'][$value]['hidden'] ? '<i>' : '').$colorDatas[$id]['colored_link'].($context['view_members'][$value]['hidden'] ? '</i>' : '');
			}
		}
	}
</add after>

<edit file>
$sourcedir/Recent.php
</edit file>

<search for>
	$posts = array();
</search for>

<add after>
	if (!empty($modSettings['MemberColorRecentLastPost']))
		$context['MemberColor_ID_MEMBER'] = array();	
</add after>

<search for>
		);
	}
	mysql_free_result($request);

	return $posts;
}
</search for>

<replace>
		);
		//The Last Posters id for the MemberColor.
		if (!empty($modSettings['MemberColorRecentLastPost']) && !empty($row['ID_MEMBER']))
				$context['MemberColor_ID_MEMBER'][$row['ID_MEMBER']] = $row['ID_MEMBER'];
	}
	mysql_free_result($request);

	// Know set the colors for the Recent posts...
	if (!empty($context['MemberColor_ID_MEMBER'])) {
		$colorDatas = load_onlineColors($context['MemberColor_ID_MEMBER']);
		if (!empty($modSettings['MemberColorRecentLastPost']) && is_array($posts))
			foreach($posts as $postkey => $postid_memcolor) 
				if(!empty($colorDatas[$postid_memcolor['poster']['id']]['colored_link']))
					$posts[$postkey]['poster']['link'] = $colorDatas[$postid_memcolor['poster']['id']]['colored_link'];
	}

	return $posts;
}
</replace>

<search for>
	$counter = $_REQUEST['start'] + 1;
	$context['posts'] = array();
</search for>

<add after>
	if (!empty($modSettings['MemberColorRecentOwner']) || !empty($modSettings['MemberColorRecentLastPost']))
		$context['MemberColor_ID_MEMBER'] = array();
</add after>

<search for>
		if ($ID_MEMBER == $row['ID_FIRST_MEMBER'])
			$board_ids['own'][$row['ID_BOARD']][] = $row['ID_MSG'];
		$board_ids['any'][$row['ID_BOARD']][] = $row['ID_MSG'];
	}
	mysql_free_result($request);
</search for>

<replace>
		if ($ID_MEMBER == $row['ID_FIRST_MEMBER'])
			$board_ids['own'][$row['ID_BOARD']][] = $row['ID_MSG'];
		$board_ids['any'][$row['ID_BOARD']][] = $row['ID_MSG'];

		//The Thread Owners id for the MemberColor.
		if (!empty($modSettings['MemberColorRecentOwner']) && !empty($row['ID_FIRST_MEMBER']))
			$context['MemberColor_ID_MEMBER'][$row['ID_FIRST_MEMBER']] = $row['ID_FIRST_MEMBER'];
		//The Last Posters id for the MemberColor.
		if (!empty($modSettings['MemberColorRecentLastPost']) && !empty($row['ID_MEMBER']))
			$context['MemberColor_ID_MEMBER'][$row['ID_MEMBER']] = $row['ID_MEMBER'];
	}
	mysql_free_result($request);

	// Know set the colors for the Recent posts...
	if (!empty($context['MemberColor_ID_MEMBER']) && is_array($context['posts'])) {
		$colorDatas = load_onlineColors($context['MemberColor_ID_MEMBER']);
		foreach($context['posts'] as $postkey => $postid_memcolor) {
			if (!empty($modSettings['MemberColorRecentLastPost']) && !empty($colorDatas[$postid_memcolor['poster']['id']]['colored_link']))
				$context['posts'][$postkey]['poster']['link'] = $colorDatas[$postid_memcolor['poster']['id']]['colored_link'];
			if (!empty($modSettings['MemberColorRecentOwner']) && !empty($colorDatas[$postid_memcolor['first_poster']['id']]['colored_link']))
				$context['posts'][$postkey]['first_poster']['link'] = $colorDatas[$postid_memcolor['first_poster']['id']]['colored_link'];
		}
	}
</replace>

<search for>
	$context['topics'] = array();
	$topic_ids = array();
</search for>

<add after>
	if (!empty($modSettings['MemberColorRecentOwner']) || !empty($modSettings['MemberColorRecentLastPost']))
		$context['MemberColor_ID_MEMBER'] = array();
</add after>

<search for>
		);

		determineTopicClass($context['topics'][$row['ID_TOPIC']]);
	}
	mysql_free_result($request);

	if ($is_topics && !empty($modSettings['enableParticipation']) && !empty($topic_ids))
</search for>

<replace>
		);

		//The Thread Owners id for the MemberColor.
		if (!empty($modSettings['MemberColorRecentOwner']) && !empty($row['ID_FIRST_MEMBER']))
			$context['MemberColor_ID_MEMBER'][$row['ID_FIRST_MEMBER']] = $row['ID_FIRST_MEMBER'];
		//The Last Posters id for the MemberColor.
		if (!empty($modSettings['MemberColorRecentLastPost']) && !empty($row['ID_LAST_MEMBER']))
			$context['MemberColor_ID_MEMBER'][$row['ID_LAST_MEMBER']] = $row['ID_LAST_MEMBER'];

		determineTopicClass($context['topics'][$row['ID_TOPIC']]);
	}
	mysql_free_result($request);

	// Know set the colors for the Recent posts...
	if (!empty($context['MemberColor_ID_MEMBER']) && is_array($context['topics'])) {
		$colorDatas = load_onlineColors($context['MemberColor_ID_MEMBER']);
		foreach($context['topics'] as $postkey => $postid_memcolor) {
			if (!empty($modSettings['MemberColorRecentLastPost']) && !empty($colorDatas[ $postid_memcolor['last_post']['member']['id']]['colored_link']))
				$context['topics'][$postkey]['last_post']['member']['link'] = $colorDatas[$postid_memcolor['last_post']['member']['id']]['colored_link'];
			if (!empty($modSettings['MemberColorRecentOwner']) && !empty($colorDatas[ $postid_memcolor['first_post']['member']['id']]['colored_link']))
				$context['topics'][$postkey]['first_post']['member']['link'] = $colorDatas[ $postid_memcolor['first_post']['member']['id']]['colored_link'];
		}
	}

	if ($is_topics && !empty($modSettings['enableParticipation']) && !empty($topic_ids))
</replace>

<search for>
				'link' => empty($row['ID_MEMBER']) ? $row['posterName'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['posterName'] . '</a>'
			),
			'subject' => $row['subject'],
</search for>

<replace>
				'link' => empty($row['ID_MEMBER']) ? (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row['posterName'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '') : '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['posterName'] . '</a>'
			),
			'subject' => $row['subject'],
</replace>

<search for>
				'link' => empty($row['ID_FIRST_MEMBER']) ? $row['firstPosterName'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_FIRST_MEMBER'] . '">' . $row['firstPosterName'] . '</a>'
</search for>

<replace>
				'link' => empty($row['ID_FIRST_MEMBER']) ? (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row['firstPosterName'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '') : '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_FIRST_MEMBER'] . '">' . $row['firstPosterName'] . '</a>'
</replace>

<search for>
				'link' => empty($row['ID_MEMBER']) ? $row['posterName'] : '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['posterName'] . '</a>'
			),
			'message' => $row['body'],
</search for>

<replace>
				'link' => empty($row['ID_MEMBER']) ? (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$row['posterName'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '') : '<a href="' . $scripturl . '?action=profile;u=' . $row['ID_MEMBER'] . '">' . $row['posterName'] . '</a>'
			),
			'message' => $row['body'],
</replace>

<edit file>
$sourcedir/PersonalMessage.php
</edit file>

<search for>
	$context['allow_hide_email'] = !empty($modSettings['allow_hideEmail']);
	$context['from_or_to'] = $context['folder'] != 'outbox' ? 'from' : 'to';
	$context['get_pmessage'] = 'prepareMessageContext';

	$labelQuery = $context['folder'] != 'outbox' ? "
			AND FIND_IN_SET('$context[current_label_id]', pmr.labels)" : '';
</search for>

<add after>
	//Correct a Modsettings sometime there is a problem, and load variables if i need them ;).
	$colormodcheck = $context['folder'] == 'outbox' ? 'MemberColorOutbox' : 'MemberColorInbox';
	$MemberSetColor = false;
	if (empty($modSettings[$colormodcheck]) && !empty($modSettings['MemberColorLink'])) 
		$modSettings['MemberColorLink'] = 0;
	if (!empty($modSettings[$colormodcheck])) {
		$context['MemberColor_ID_MEMBER'] = array();
		$context['MemberColor_IM_ID'] = array();
	}
</add after>

<search for>
		}
		mysql_free_result($request);

		// Load any users....
		$posters = array_unique($posters);
		if (!empty($posters))
			loadMemberData($posters);
</search for>

<replace>
			if (!empty($row['ID_MEMBER_TO']) && !empty($modSettings[$colormodcheck])) {
				$MemberSetColor = true;
				$posters[] = $row['ID_MEMBER_TO'];
				// Hmmm somehow i must know what i should replace... i hope i do it right...
				$context['MemberColor_IM_ID'][$row['ID_PM']][empty($row['bcc']) ? 'to' : 'bcc'][] = $row['ID_MEMBER_TO'];
			}
			elseif (empty($row['ID_MEMBER_TO']) && (!empty($modSettings['MemberColorOutbox']) || !empty($modSettings['MemberColorInbox']))) 
				$context['MemberColor_IM_ID'][$row['ID_PM']][empty($row['bcc']) ? 'to' : 'bcc'][] = NULL;
		}

		// Load any users....
		$posters = array_unique($posters);
		if (!empty($posters))
			loadMemberData($posters);

		//So i must correct the link ;) i need only the membercontext for this (a little bit faster)
		if ($MemberSetColor && !empty($context['MemberColor_IM_ID'])) {
			//Now i can Load the Missing global :)
			global $user_profile;
	
			//So let's replace the links...
			foreach($context['MemberColor_IM_ID'] as $pmid => $pmidarray) {
				if (!empty($pmidarray['to'])) 
					foreach($pmidarray['to'] as $pm_meber_key => $pm_member_id) {
						if(!empty($recipients[$pmid]['to'][$pm_meber_key]) && (!empty($user_profile[$pm_member_id]['member_group_color']) || !empty($user_profile[$pm_member_id]['post_group_color']))) {
							$profile = $user_profile[$pm_member_id];
							$recipients[$pmid]['to'][$pm_meber_key] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';
						}
					}
				if (!empty($pmidarray['bcc'])) 					
					foreach($pmidarray['bcc']  as $pm_meber_key => $pm_member_id) {
						if(!empty($recipients[$pmid]['bcc'][$pm_meber_key]) && (!empty($user_profile[$pm_member_id]['member_group_color']) || !empty($user_profile[$pm_member_id]['post_group_color']))) {
							$profile = $user_profile[$pm_member_id];
							$recipients[$pmid]['bcc'][$pm_meber_key] = '<a href="' . $scripturl . '?action=profile;u=' . $profile['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $profile['realName'] . '"><span style="color:'.(!empty($profile['member_group_color']) ? $profile['member_group_color'] : $profile['post_group_color']).';">' . $profile['realName'] . '</span></a>';
						}
					}
			}
		}
</replace>

<edit file>
$sourcedir/Stats.php
</edit file>

<search for>
		$context['top_posters'][] = array(
			'name' => $row_members['realName'],
			'id' => $row_members['ID_MEMBER'],
			'num_posts' => $row_members['posts'],
			'href' => $scripturl . '?action=profile;u=' . $row_members['ID_MEMBER'],
			'link' => '<a href="' . $scripturl . '?action=profile;u=' . $row_members['ID_MEMBER'] . '">' . $row_members['realName'] . '</a>'
		);
</search for>

<add after>
		
		if (!empty($modSettings['MemberColorStats']))
			$context['MemberColor_ID_MEMBER'][$row_members['ID_MEMBER']] = $row_members['ID_MEMBER'];
</add after>

<search for>
		$context['top_boards'][] = array(
			'id' => $row_board['ID_BOARD'],
			'name' => $row_board['name'],
			'num_posts' => $row_board['numPosts'],
			'href' => $scripturl . '?board=' . $row_board['ID_BOARD'] . '.0',
			'link' => '<a href="' . $scripturl . '?board=' . $row_board['ID_BOARD'] . '.0">' . $row_board['name'] . '</a>'
		);
</search for>

<add after>

		if (!empty($modSettings['MemberColorStats']))
			$context['MemberColor_ID_MEMBER'][$row_members['ID_MEMBER_STARTED']] = $row_members['ID_MEMBER_STARTED'];
</add after>

<search for>
		$context['top_time_online'][] = array(
			'id' => $row_members['ID_MEMBER'],
			'name' => $row_members['realName'],
			'time_online' => $timelogged,
			'seconds_online' => $row_members['totalTimeLoggedIn'],
			'href' => $scripturl . '?action=profile;u=' . $row_members['ID_MEMBER'],
			'link' => '<a href="' . $scripturl . '?action=profile;u=' . $row_members['ID_MEMBER'] . '">' . $row_members['realName'] . '</a>'
		);
</search for>

<add after>

		if (!empty($modSettings['MemberColorStats']))
			$context['MemberColor_ID_MEMBER'][$row_members['ID_MEMBER']] = $row_members['ID_MEMBER'];
</add after>

<search for>
	foreach ($context['top_time_online'] as $i => $member)
		$context['top_time_online'][$i]['time_percent'] = round(($member['seconds_online'] * 100) / $max_time_online);
</search for>

<add after>
	
	if (!empty($modSettings['latestMember']) && !empty($modSettings['MemberColorLatestMember']))
		$context['MemberColor_ID_MEMBER'][$modSettings['latestMember']] = $modSettings['latestMember'];
	
	//Yeah baby give me some colors =) .oO(sometimes who read this ;D).
	if (!empty($context['MemberColor_ID_MEMBER'])) {
		$colorDatas = load_onlineColors($context['MemberColor_ID_MEMBER']);
		if (!empty($modSettings['MemberColorStats'])) {
			// First the Top Posters =)
			foreach($context['top_posters'] as $key => $value) {
				if(!empty($colorDatas[$context['top_posters'][$key]['id']]['colored_link']))
					$context['top_posters'][$key]['link'] = $colorDatas[$context['top_posters'][$key]['id']]['colored_link'];
			}
			// First the Top Starter =)		
			foreach($context['top_starters'] as $key => $value) {
				if(!empty($colorDatas[$context['top_starters'][$key]['id']]['colored_link']))
					$context['top_starters'][$key]['link'] = $colorDatas[$context['top_starters'][$key]['id']]['colored_link'];
			}
			// First the Top Onliner =)				
			foreach($context['top_time_online'] as $key => $value) {
				if(!empty($colorDatas[$context['top_time_online'][$key]['id']]['colored_link']))
					$context['top_time_online'][$key]['link'] = $colorDatas[$context['top_time_online'][$key]['id']]['colored_link'];
			}
		}
		if (!empty($modSettings['latestMember']) && !empty($modSettings['MemberColorLatestMember']))
			$context['latest_member']['link'] = $colorDatas[$modSettings['latestMember']]['colored_link'];
	}
</add after>

<edit file>
$sourcedir/Subs.php
</edit file>

<search for>
	// This looks weird, but it's because BoardIndex.php references the variable.
	$context['common_stats']['latest_member'] = array(
		'id' => $modSettings['latestMember'],
		'name' => $modSettings['latestRealName'],
		'href' => $scripturl . '?action=profile;u=' . $modSettings['latestMember'],
		'link' => '<a href="' . $scripturl . '?action=profile;u=' . $modSettings['latestMember'] . '">' . $modSettings['latestRealName'] . '</a>',
	);
</search for>

<add after>
	//Latest user need some colors... How could you put this into this file... i hate you... i hope no one read this :P
	if (!empty($modSettings['latestMember']) && !empty($modSettings['MemberColorLatestMember'])) {
		$data = load_onlineColors($modSettings['latestMember'], true, true); //I'm sure this is single user
		$context['common_stats']['latest_member']['link'] = $data['colored_link'];
	}
</add after>

<edit file>
$sourcedir/Search.php
</edit file>

<search for>
		$memberContext[$message['ID_MEMBER']]['link'] = $message['posterName'];
</search for>

<replace>
		$memberContext[$message['ID_MEMBER']]['link'] = (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$message['posterName'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '');
</replace>

<search for>
	$output = array_merge($context['topics'][$message['ID_MSG']], array(
</search for>

<replace>
	//Generate the Started By Search Link... This is not fine, because i need to load each sepperate...
	//Ah and add correct Guest links ;D
	$first_post_link = !empty($message['first_member_id']) ? '<a href="' . $scripturl . '?action=profile;u=' . $message['first_member_id'] . '" title="' . $txt[92] . ' ' . $message['first_member_name'] . '">' . $message['first_member_name'] . '</a>' : (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$message['first_member_name'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '');
	$last_post_link = !empty($message['last_member_id']) ? '<a href="' . $scripturl . '?action=profile;u=' . $message['last_member_id'] . '" title="' . $txt[92] . ' ' . $message['last_member_name'] . '">' . $message['last_member_name'] . '</a>' : (!empty($modSettings['MemberColorGuests']) ? '<span style="color:'.$modSettings['MemberColorGuests'].';">' : '').$message['last_member_name'].(!empty($modSettings['MemberColorGuests']) ? '</span>' : '');
	if(!empty($modSettings['MemberColorAllSearch'])) {
		$load = array();
		if(!empty($message['first_member_id']))
			$load[] = $message['first_member_id'];
		if(!empty($message['first_member_id']))
			$load[] = $message['last_member_id'];
		if(!empty($load)) {
			$colorDatas = load_onlineColors($load);
			if(!empty($colorDatas[$message['first_member_id']]['colored_link']))
				$first_post_link = $colorDatas[$message['first_member_id']]['colored_link'];
			if(!empty($colorDatas[$message['last_member_id']]['colored_link']))
				$last_post_link = $colorDatas[$message['last_member_id']]['colored_link'];
		}
	}

	$output = array_merge($context['topics'][$message['ID_MSG']], array(
</replace>

<search for>
				'link' => !empty($message['first_member_id']) ? '<a href="' . $scripturl . '?action=profile;u=' . $message['first_member_id'] . '" title="' . $txt[92] . ' ' . $message['first_member_name'] . '">' . $message['first_member_name'] . '</a>' : $message['first_member_name']
</search for>

<replace>
				'link' => $first_post_link
</replace>

<search for>
				'link' => !empty($message['last_member_id']) ? '<a href="' . $scripturl . '?action=profile;u=' . $message['last_member_id'] . '" title="' . $txt[92] . ' ' . $message['last_member_name'] . '">' . $message['last_member_name'] . '</a>' : $message['last_member_name']
</search for>

<replace>
				'link' => $last_post_link
</replace>

<edit file>
$themedir/Calendar.template.php
</edit file>

<search for>
						<a href="', $scripturl, '?action=profile;u=', $member['id'], '">', $member['name'], isset($member['age']) ? ' (' . $member['age'] . ')' : '', '</a>', $member['is_last'] ? '' : ', ';
</search for>

<replace>
						<a href="', $scripturl, '?action=profile;u=', $member['id'], '"'. (!empty($member['color']) ? (empty($modSettings['MemberColorLinkOldSpanStyle']) ? ' style="color:'.$member['color'].'">' : '><span style="color:'.$member['color'].';">') : '>'), $member['name'], isset($member['age']) ? ' (' . $member['age'] . ')' : '', (!empty($member['color']) && !empty($modSettings['MemberColorLinkOldSpanStyle']) ? '</span>' : ''), '</a>', $member['is_last'] ? '' : ', ';
</replace>

<edit file>
$themedir/BoardIndex.template.php
</edit file>

<search for>
				<a href="', $scripturl, '?action=profile;u=', $member['id'], '">', $member['is_today'] ? '<b>' : '', $member['name'], $member['is_today'] ? '</b>' : '', isset($member['age']) ? ' (' . $member['age'] . ')' : '', '</a>', $member['is_last'] ? '<br />' : ', ';
</search for>

<replace>
				', ($member['is_today'] ? '<b>' : ''), '<a href="', $scripturl, '?action=profile;u=', $member['id'], '"'. (!empty($member['color']) ? (empty($modSettings['MemberColorLinkOldSpanStyle']) ? ' style="color:'.$member['color'].'">' : '><span style="color:'.$member['color'].';">') : '>'), $member['name'], isset($member['age']) ? ' (' . $member['age'] . ')' : '', (!empty($member['color']) && !empty($modSettings['MemberColorLinkOldSpanStyle']) ? '</span>' : ''), '</a>', ($member['is_today'] ? '</b>' : ''), $member['is_last'] ? '' : ', ';
</replace>

<edit file>
$themedir/Profile.template.php
</edit file>

<search for>
					<td><b>', $txt[68], ': </b></td>
					<td>', $context['member']['name'], '</td>
</search for>

<replace>
					<td><b>', $txt[68], ': </b></td>
					<td>', $context['member']['colored_name'], '</td>
</replace>